"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createUseTailwindStyles = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const css_media_queries_1 = require("./css-media-queries");
const tailwind_context_1 = require("./tailwind-context");
const createUseTailwindStyles = (styles) => {
    return () => {
        const ctx = (0, tailwind_context_1.useTailwind)();
        return (0, react_1.useMemo)(() => {
            const deviceWidth = react_native_1.Dimensions.get("window").width;
            const stylesheet = Object.fromEntries(Object.entries(styles).map(([key, arr]) => {
                const { mergedStyles, id } = arr
                    .filter(({ platform, dark, selectors, breakpoint }) => 
                // Check platform
                (!platform || platform === react_native_1.Platform.OS) &&
                    // Check dark mode
                    (!dark || react_native_1.Platform.OS === "web" || ctx.dark) &&
                    // Selectors are only valid on web
                    (!selectors.length || react_native_1.Platform.OS === "web") &&
                    // Validate device size on non-web
                    (!breakpoint ||
                        react_native_1.Platform.OS === "web" ||
                        deviceWidth >=
                            parseInt(breakpoint.minWidth.replace("px", ""), 10)))
                    .reduce((acc, cur) => {
                    const requiresMediaQuery = cur.dark || cur.selectors.length || cur.breakpoint;
                    if (react_native_1.Platform.OS === "web" && requiresMediaQuery) {
                        // Add style to css stylesheet
                        (0, css_media_queries_1.registerStyle)(cur);
                        return {
                            // Skip responsive styles
                            mergedStyles: acc.mergedStyles,
                            id: [acc.id, cur.id].filter(Boolean).join(" "),
                        };
                    }
                    return {
                        mergedStyles: Object.assign(acc.mergedStyles, cur.style),
                        id: acc.id,
                    };
                }, { mergedStyles: {}, id: "" });
                // Add non-enumerable id property to the style object to be applied to data-tw.
                Object.defineProperty(mergedStyles, "id", {
                    value: id,
                    enumerable: false,
                });
                return [key, mergedStyles];
            }));
            return stylesheet;
        }, [ctx]);
    };
};
exports.createUseTailwindStyles = createUseTailwindStyles;
exports.createUseTailwindStyles.React = react_1.default;
