"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleLibImport = void 0;
const babel_plugin_macros_1 = require("babel-plugin-macros");
function handleLibImport(params) {
    const { path, program, t } = params;
    const importNode = path.get("name");
    if (Array.isArray(importNode))
        throw new babel_plugin_macros_1.MacroError(`Invalid import "[${importNode.map(({ node }) => node).join(", ")}]"`);
    const importName = importNode.node;
    if (typeof importName !== "string")
        throw new babel_plugin_macros_1.MacroError(`Invalid import "${importName}"`);
    // Replace with imported version
    if (path.isJSXIdentifier())
        path.replaceWith(t.jsxMemberExpression(t.jsxIdentifier(program.state.importIdentifier), t.jsxIdentifier(importName)));
    else
        path.replaceWith(t.memberExpression(t.identifier(program.state.importIdentifier), t.identifier(importName)));
}
exports.handleLibImport = handleLibImport;
