"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleTwProp = void 0;
const babel_plugin_macros_1 = require("babel-plugin-macros");
const utils_1 = require("./utils");
function handleTwProp(params) {
    const { path, component } = params;
    if (path.node.name.name !== "tw")
        return;
    const nodeValue = path.get("value");
    if (!nodeValue.isStringLiteral())
        throw new babel_plugin_macros_1.MacroError(`Only plain strings can be used with the "tw" prop. TODO: Add suggestions.`);
    const styleIdentifier = (0, utils_1.addStyleRule)(Object.assign(Object.assign({}, params), { createStylesPath: component.state.createStylesPath, style: nodeValue.node.value }));
    (0, utils_1.moveTwPropToStyle)(Object.assign(Object.assign({}, params), { identifier: styleIdentifier }));
    (0, utils_1.addResponsiveId)(Object.assign(Object.assign({}, params), { path: path.parentPath.parentPath, identifier: styleIdentifier }));
}
exports.handleTwProp = handleTwProp;
