"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTailwind = exports.TailwindProvider = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const utils_1 = require("./utils");
const DEFAULT_CONTEXT = {
    dark: (0, utils_1.getInitialColorScheme)() === "dark",
    platform: react_native_1.Platform.OS,
};
const Context = (0, react_1.createContext)(DEFAULT_CONTEXT);
const TailwindProvider = ({ dark, children }) => {
    // Memoize the context value to skip rerenders
    const value = (0, react_1.useMemo)(() => (Object.assign(Object.assign({}, DEFAULT_CONTEXT), { dark: Boolean(dark) })), [dark]);
    (0, react_1.useEffect)(() => {
        if (react_native_1.Platform.OS === "web" && typeof document !== "undefined") {
            document.body.classList.add(dark ? "rntwm-dark" : "rntwm-light");
            document.body.classList.remove(dark ? "rntwm-light" : "rntwm-dark");
            if (typeof dark !== "undefined") {
                // Persist the selection in a cookie
                (0, utils_1.setColorSchemeCookie)(dark ? "dark" : "light");
            }
        }
    }, [dark]);
    return react_1.default.createElement(Context.Provider, { value: value }, children);
};
exports.TailwindProvider = TailwindProvider;
const useTailwind = () => {
    const ctx = (0, react_1.useContext)(Context);
    return ctx;
};
exports.useTailwind = useTailwind;
