import { MacroError } from "babel-plugin-macros";
export function handleLibImport(params) {
    const { path, program, t } = params;
    const importNode = path.get("name");
    if (Array.isArray(importNode))
        throw new MacroError(`Invalid import "[${importNode.map(({ node }) => node).join(", ")}]"`);
    const importName = importNode.node;
    if (typeof importName !== "string")
        throw new MacroError(`Invalid import "${importName}"`);
    // Replace with imported version
    if (path.isJSXIdentifier())
        path.replaceWith(t.jsxMemberExpression(t.jsxIdentifier(program.state.importIdentifier), t.jsxIdentifier(importName)));
    else
        path.replaceWith(t.memberExpression(t.identifier(program.state.importIdentifier), t.identifier(importName)));
}
