import { MacroError } from "babel-plugin-macros";
import { addResponsiveId, addStyleRule, moveTwPropToStyle } from "./utils";
export function handleTwProp(params) {
    const { path, component } = params;
    if (path.node.name.name !== "tw")
        return;
    const nodeValue = path.get("value");
    if (!nodeValue.isStringLiteral())
        throw new MacroError(`Only plain strings can be used with the "tw" prop. TODO: Add suggestions.`);
    const styleIdentifier = addStyleRule(Object.assign(Object.assign({}, params), { createStylesPath: component.state.createStylesPath, style: nodeValue.node.value }));
    moveTwPropToStyle(Object.assign(Object.assign({}, params), { identifier: styleIdentifier }));
    addResponsiveId(Object.assign(Object.assign({}, params), { path: path.parentPath.parentPath, identifier: styleIdentifier }));
}
