var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { createMacro, MacroError, } from "babel-plugin-macros";
import fs from "fs";
import { resolve } from "path";
import { addCreateUseTailwindStyles, addImport, addUseStylesCall, findParentFunction, } from "./utils";
import { handleTwProp } from "./handle-tw-prop";
import { handleHook } from "./handle-hook";
import { handleLibImport } from "./handle-lib-import";
import { resolveTailwindConfig } from "./resolve-tailwind-config";
const macro = (params) => {
    var _a, _b;
    const _c = params.references, { 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    default: _default, useTailwindStyles: useTailwindStylesReferences = [] } = _c, libImports = __rest(_c, ["default", "useTailwindStyles"]), { state, babel: { types: t }, config = {} } = params;
    const program = state.file.path;
    addImport(Object.assign(Object.assign({}, params), { t, path: program, program }));
    // Resolve custom tailwind config
    const sourceRoot = (_a = state.file.opts.sourceRoot) !== null && _a !== void 0 ? _a : ".";
    const configPath = resolve(sourceRoot, (_b = config.config) !== null && _b !== void 0 ? _b : "./tailwind.config.js");
    if (config.config && !fs.existsSync(configPath))
        throw new MacroError(`Couldn't find custom tailwind config at ${configPath}.`);
    program.state.tailwindConfig = resolveTailwindConfig(configPath);
    /**
     * Traverse and collect all tw props on the surrounding component function in a first run.
     */
    program.traverse({
        JSXElement(path) {
            var _a;
            const allAttributes = path.get("openingElement").get("attributes");
            const jsxAttributes = allAttributes.filter((a) => a.isJSXAttribute());
            const twProp = jsxAttributes.find((a) => a.node.name.name === "tw");
            // Nothing to do
            if (!twProp)
                return;
            const component = findParentFunction(Object.assign(Object.assign({}, params), { path,
                t,
                program }));
            if (!component.state.stylesIdentifier)
                component.state.stylesIdentifier =
                    component.scope.generateUid("tailwindStyles");
            if (!component.state.useStylesIdentifier)
                component.state.useStylesIdentifier =
                    component.scope.generateUid("useStyles");
            if (!((_a = component.state) === null || _a === void 0 ? void 0 : _a.createStylesPath)) {
                const createStylesPath = addCreateUseTailwindStyles(Object.assign(Object.assign({}, params), { t,
                    program,
                    path, identifier: component.state.useStylesIdentifier }));
                component.state.createStylesPath = createStylesPath;
            }
            const body = component.get("body");
            if (body.isBlockStatement() && !component.state.useStylesPath) {
                const useStyles = addUseStylesCall(Object.assign(Object.assign({}, params), { t,
                    program, path: body, identifier: component.state.stylesIdentifier, useStylesIdentifier: component.state.useStylesIdentifier }));
                component.state.useStylesPath = useStyles;
            }
            const stylesObject = component.state.useStylesPath.get("declarations.0.init.arguments.0");
            component.state.useStylesArgumentPath = stylesObject;
            handleTwProp(Object.assign(Object.assign({}, params), { path: twProp, t, program, component }));
        },
    });
    useTailwindStylesReferences.forEach((path) => handleHook(Object.assign(Object.assign({}, params), { path, program, t })));
    Object.values(libImports)
        .flat()
        .forEach((path) => handleLibImport(Object.assign(Object.assign({}, params), { path, program, t })));
    program.scope.crawl();
};
export default createMacro(macro, {
    configName: "reactNativeTailwind",
});
